CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ
  Mult : "MulDiv"
  Debug : "FullDuplexSerial"

PUB Main | c,s,e

  Debug.Start(31, 30, 0, 115200)
  Mult.Start
  repeat                                            
    c := Debug.Rx
    Debug.Str(string(13,10,"JDForth Multiplication Test"))
    repeat c from 1 to 29 step 4
      '355 / 113 = pi  accurate to 8.5e-8
      MulDiv(1 << c,355,113)
    repeat c from 1 to 29 step 4  
      MulDivRem(c,c,5)
    repeat c from 1 to 29 step 4  
      Mul64(1<<c,1<<c + 1)  

PRI MulDiv(v1, v2, v3) | r
  r := Mult.MulDiv(v1, v2, v3)
  Debug.Tx(13)
  Debug.Tx(10)
  Debug.Dec(v1)
  Debug.Tx(32)
  Debug.Tx("X")
  Debug.Tx(32)
  Debug.Dec(v2)
  Debug.Tx(32)
  Debug.Tx("/")
  Debug.Tx(32)
  Debug.Dec(v3)
  Debug.Tx(32)
  Debug.Tx("=")
  Debug.Tx(32)
  Debug.Dec(r)

PRI MulDivRem(v1, v2, v3)
  Mult.MulDivRem(v1, v2, v3)
  Debug.Tx(13)
  Debug.Tx(10)
  Debug.Dec(v1)
  Debug.Tx(32)
  Debug.Tx("X")
  Debug.Tx(32)
  Debug.Dec(v2)
  Debug.Tx(32)
  Debug.Tx("/")
  Debug.Tx(32)
  Debug.Dec(v3)
  Debug.Tx(32)
  Debug.Tx("=")
  Debug.Tx(32)
  Debug.Dec(Mult.Pop)
  Debug.Tx(32)
  Debug.Dec(Mult.Pop)

PRI Mul64(v1, v2) | vh, vl
  Mult.Mul64(v1, v2)
  Debug.Tx(13)
  Debug.Tx(10)
  Debug.Dec(v1)
  Debug.Tx(32)
  Debug.Tx("X")
  Debug.Tx(32)
  Debug.Dec(v2)
  Debug.Tx(32)
  Debug.Tx("=")
  Debug.Tx(32)
  vl := Mult.Pop
  vh := Mult.Pop
  Debug.Dec(vh)
  Debug.Str(String(" x 2^32 + "))
  Debug.Dec(vl)
          